//+------------------------------------------------------------------+
//|                                          BarsCalculatedTests.mq5 |
//|                        Copyright 2020, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2020, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property indicator_chart_window
#include <LorioTools\Standards.mqh>
input color plot_color=clrWhite;//Plot color for indicator 
input int nonusevalue=50;//non use value for indicator 
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
//ma handle 
  ENUM_TIMEFRAMES this_tf,higher_tf;
  string otherSymbol;
  string nicknames[]={"Native","Same Higher TF","Totally Different"};
  int bars_calculated[]={0,0,0};
  int handles[]={INVALID_HANDLE,INVALID_HANDLE,INVALID_HANDLE};
  bool oninitreported=false,oncalculatereported=false;
  
int OnInit()
  {
  //Pick a random symbol
  otherSymbol=PickASymbolOtherThanThis(_Symbol);
  oninitreported=false;oncalculatereported=false;
  Print("Random symbol : "+otherSymbol);
//--- indicator buffers mapping
  this_tf=Period();
  higher_tf=FindHigherTimeframe(this_tf);//set the higher timeframe
  //Prepare names of called indicators 
  nicknames[0]=_Symbol+"("+EnumToString(this_tf)+")";
  nicknames[1]=_Symbol+"("+EnumToString(higher_tf)+")";
  nicknames[2]=otherSymbol+"("+EnumToString(higher_tf)+")";
  Print("This TF : "+EnumToString(this_tf)+" Higher TF : "+EnumToString(higher_tf));
  //create indicator handles , mind the subfolder
  handles[0]=iCustom(_Symbol,_Period,"SlaveIndicator",plot_color,nonusevalue);
  handles[1]=iCustom(_Symbol,higher_tf,"SlaveIndicator",plot_color,nonusevalue);
  handles[2]=iCustom(otherSymbol,higher_tf,"SlaveIndicator",plot_color,nonusevalue);
  //test the handles
  bool bounce=false;
  for(int q=0;q<3;q++){if(handles[q]==INVALID_HANDLE){Print("Cant Get Handle of "+nicknames[q]);bounce=true;}}
  if(bounce){return(INIT_FAILED);}
  //take initial measurement , we will track this because the indicators reported full rates being accesed upon initialization
  for(int q=0;q<3;q++){
  bars_calculated[q]=BarsCalculated(handles[q]);
  Print(nicknames[q]+" BarsCalculated("+IntegerToString(bars_calculated[q])+")["+the_time()+"]");
  }
//---
  if(!oninitreported){
  Print("MASTER INDICATOR : ONINIT END ["+the_time()+"]");
  oninitreported=true;
  }
   return(INIT_SUCCEEDED);
  }
string the_time(){return(TimeToString(TimeLocal(),TIME_DATE|TIME_MINUTES|TIME_SECONDS));}
string PickASymbolOtherThanThis(string notthis)
{
int st=SymbolsTotal(true);
string pool[];
ArrayResize(pool,st-1,0);
int pt=-1;
for(int p=0;p<st;p++){
if(SymbolName(p,true)!=notthis){pt++;pool[pt]=SymbolName(p,true);}
}
MathSrand(GetTickCount());
int rando_commando=(int)(((double)((st-1)*MathRand()))/32768.0);
return(pool[rando_commando]);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
double receiver_of_samples[];
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
  if(!oncalculatereported){
  Print("MASTER INDICATOR : ONCALCULATE HIT ["+the_time()+"]");
  oncalculatereported=true;
  }
//---
  //take initial measurement , we will track this because the indicators reported full rates being accesed upon initialization
    int new_bars_calculated[]={-1,-1,-1};
    bool any_change=false;
    for(int q=0;q<3;q++){new_bars_calculated[q]=BarsCalculated(handles[q]);if(new_bars_calculated[q]!=bars_calculated[q]){any_change=true;}}
  //if any change (to not tire the i's)
    if(any_change)
    {
    for(int q=0;q<3;q++){
    bars_calculated[q]=new_bars_calculated[q];
    Print(nicknames[q]+" BarsCalculated("+IntegerToString(bars_calculated[q])+")["+the_time()+"]");
    }
    //for statuses that are not -1 we will do sampling of the data 
    for(int q=0;q<3;q++)
      {
      if(bars_calculated[q]!=-1){
      ResetLastError();
      int what_to_request=rando_commando_of(bars_calculated[q]);//bars calculated not -1 so we will keep the request within whats calculated 
      int c=CopyBuffer(handles[q],0,what_to_request,1,receiver_of_samples);
        if(GetLastError()!=0){Print("Cant Get Sample #"+IntegerToString(what_to_request)+" for "+nicknames[q]+" error "+IntegerToString(GetLastError()));}
        if(GetLastError()==0){
        Print(nicknames[q]+" Sample #"+IntegerToString(what_to_request)+" = "+DoubleToString(receiver_of_samples[0],5));
        }
      }
     }
   //for statuses that are not -1 we will do sampling of the data ends here
    }
  //if any change ends here 
//--- return value of prev_calculated for next call
   return(rates_total);
  }
void OnDeinit(const int reason)
  {
  ArrayFree(receiver_of_samples);
  }
int rando_commando_of(int total)
{
MathSrand(GetTickCount());
int rando_commando=(int)(((double)((total-1)*MathRand()))/32768.0);
return(rando_commando);
}